
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>常见的PHP五种设计模式小结 / iVAN</title>

    <meta name="description" content="常见的PHP五种设计模式小结 设计模式 一书将设计模式引入软件社区,该书的作者是 Erich Gamma.Richard Helm.Ralph Johnson 和 John Vlissides Design(俗称 &quot;四人帮&quot;).所介绍的设计模式背后的核心概念非常简单.经过多年的软件开发实践,Gamma 等人发现了某些具有固定设计的模式,就像建筑师设计房子和建筑物一样,可以为浴室的位置或厨房的构造方式开发模板.使用这些模板或者说设计模式 意味着可以更快地设计更好的建筑物.同样的概念也适用于软件. 设计模式不 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">常见的PHP五种设计模式小结</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><em>设计模式</em> 一书将设计模式引入软件社区，该书的作者是 Erich Gamma、Richard Helm、Ralph Johnson 和 John Vlissides Design（俗称 “四人帮”）。所介绍的设计模式背后的核心概念非常简单。经过多年的软件开发实践，Gamma 等人发现了某些具有固定设计的模式，就像建筑师设计房子和建筑物一样，可以为浴室的位置或厨房的构造方式开发模板。使用这些模板或者说<em>设计模式</em> 意味着可以更快地设计更好的建筑物。同样的概念也适用于软件。</p>
<p>设计模式不仅代表着更快开发健壮软件的有用方法，而且还提供了以友好的术语封装大型理念的方法。例如，您可以说您正在编写一个提供松散耦合的消息传递系统，也可以说你正在编写名称为<em>观察者</em> 的模式。</p>
<p>用较小的示例展示模式的价值是非常困难的。这往往有些大材小用的意味，因为模式实际上是在大型代码库中发挥作用的。本文不展示大型应用程序，所以您需要思索的是在您自己的大型应用程序中应用示例原理的方法 —— 而不是本文演示的代码本身。这不是说您不应该在小应用程序中使用模式。很多良好的应用程序都以小应用程序为起点，逐渐发展到大型应用程序，所以没有理由不以此类扎实的编码实践为基础。</p>
<p>既然您已经了解了设计模式以及它们的有用之处，现在我们来看看 PHP V5 的五种常用模式。</p>
<p>工厂模式</p>
<p>最初在<em>设计模式</em> 一书中，许多设计模式都鼓励使用<em>松散耦合</em>。要理解这个概念，让我们最好谈一下许多开发人员从事大型系统的艰苦历程。在更改一个代码片段时，就会发生问题，系统其他部分 —— 您曾认为完全不相关的部分中也有可能出现级联破坏。</p>
<p>该问题在于<em>紧密耦合</em> 。系统某个部分中的函数和类严重依赖于系统的其他部分中函数和类的行为和结构。您需要一组模式，使这些类能够相互通信，但不希望将它们紧密绑定在一起，以避免出现联锁。</p>
<p>在大型系统中，许多代码依赖于少数几个关键类。需要更改这些类时，可能会出现困难。例如，假设您有一个从文件读取的 <code>User</code> 类。您希望将其更改为从数据库读取的其他类，但是，所有的代码都引用从文件读取的原始类。这时候，使用工厂模式会很方便。</p>
<p><em>工厂模式</em> 是一种类，它具有为您创建对象的某些方法。您可以使用工厂类创建对象，而不直接使用 <code>new</code>。这样，如果您想要更改所创建的对象类型，只需更改该工厂即可。使用该工厂的所有代码会自动更改。</p>
<p>清单 1 显示工厂类的一个示列。等式的服务器端包括两个部分：数据库和一组 PHP 页面，这些页面允许您添加反馈、请求反馈列表并获取与特定反馈相关的文章。</p>
<p><b>清单 1. Factory1.php</b><br />
<table>
<tr>
<td>
<pre>&lt;?phpinterface IUser{ function getName();}

class User implements IUser{ public function __construct( $id ) { }

public function getName() {  return "Jack"; }}

class UserFactory{ public static function Create( $id ) {  return new User( $id ); }}

$uo = UserFactory::Create( 1 );echo( $uo-&gt;getName()."\n" );?&gt;</pre>
</td>
</tr>
</table>
<p><code>IUser</code> 接口定义用户对象应执行什么操作。<code>IUser</code> 的实现称为 <code>User</code>，<code>UserFactory</code> 工厂类则创建 <code>IUser</code> 对象。此关系可以用图 1 中的 UML 表示。</p>
<p><b>图 1. 工厂类及其相关 IUser 接口和用户类</b><br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAxMTMyNjE2NTMyNDk4LmdpZg==.jpg"></p>
<p>如果您使用 <code>php</code> 解释器在命令行上运行此代码，将得到如下结果：</p>
<table>
<tr>
<td>
<pre>% php factory1.php Jack%</pre>
</td>
</tr>
</table>
<p>测试代码会向工厂请求 <code>User</code> 对象，并输出 <code>getName</code> 方法的结果。</p>
<p>有一种工厂模式的变体使用工厂方法。类中的这些公共静态方法构造该类型的对象。如果创建此类型的对象非常重要，此方法非常有用。例如，假设您需要先创建对象，然后设置许多属性。此版本的工厂模式会将该进程封装在单个位置中，这样，不用复制复杂的初始化代码，也不必将复制好的代码在在代码库中到处粘贴。</p>
<p>清单 2 显示使用工厂方法的一个示例。</p>
<p><b>清单 2. Factory2.php</b><br />
<table>
<tr>
<td>
<pre>&lt;?phpinterface IUser{ function getName();}

class User implements IUser{ public static function Load( $id )  {    return new User( $id ); }

public static function Create( )  {    return new User( null ); }

public function __construct( $id ) { }

public function getName() {  return "Jack"; }}

$uo = User::Load( 1 );echo( $uo-&gt;getName()."\n" );?&gt;</pre>
</td>
</tr>
</table>
<p>这段代码要简单得多。它仅有一个接口 <code>IUser</code> 和一个实现此接口的 <code>User</code> 类。<code>User</code> 类有两个创建对象的静态方法。此关系可用图 2 中的 UML 表示。</p>
<p><b>图 2. IUser 接口和带有工厂方法的 user 类</b><br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAxMTMyNjE2NTM5MjE5LmdpZg==.jpg"></p>
<p>在命令行中运行脚本产生的结果与清单 1 的结果相同，如下所示：</p>
<table>
<tr>
<td>
<pre>% php factory2.php Jack%</pre>
</td>
</tr>
</table>
<p>如上所述，有时此类模式在规模较小的环境中似乎有些大材小用。不过，最好还是学习这种扎实的编码形式，以便应用于任意规模的项目中。</p>
<p>单元素模式</p>
<p>某些应用程序资源是<em>独占的</em>，因为有且只有一个此类型的资源。例如，通过数据库句柄到数据库的连接是独占的。您希望在应用程序中共享数据库句柄，因为在保持连接打开或关闭时，它是一种开销，在获取单个页面的过程中更是如此。</p>
<p>单元素模式可以满足此要求。如果应用程序每次包含且仅包含一个对象，那么这个对象就是一个<em>单元素</em>（Singleton）。清单 3 中的代码显示了 PHP V5 中的一个数据库连接单元素。</p>
<p><b>清单 3. Singleton.php</b><br />
<table>
<tr>
<td>
<pre>&lt;?phprequire_once("DB.php");

class DatabaseConnection{ public static function get() {  static $db = null;  if ( $db == null )   $db = new DatabaseConnection();  return $db; }

private $_handle = null;

private function __construct() {  $dsn = "mysql://root:password@localhost/photos";  $this-&gt;_handle =&amp; DB::Connect( $dsn, array() ); }

public function handle() {  return $this-&gt;_handle; }}

print( "Handle = ".DatabaseConnection::get()-&gt;handle()."\n" );print( "Handle = ".DatabaseConnection::get()-&gt;handle()."\n" );?&gt;</pre>
</td>
</tr>
</table>
<p>此代码显示名为 <code>DatabaseConnection</code> 的单个类。您不能创建自已的 <code>DatabaseConnection</code>，因为构造函数是专用的。但使用静态 <code>get</code> 方法，您可以获得且仅获得一个 <code>DatabaseConnection</code> 对象。此代码的 UML 如图 3 所示。</p>
<p><b>图 3. 数据库连接单元素</b><br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAxMTMyNjE2NTM5MzAzLmdpZg==.jpg"></p>
<p>在两次调用间，<code>handle</code> 方法返回的数据库句柄是相同的，这就是最好的证明。您可以在命令行中运行代码来观察这一点。</p>
<table>
<tr>
<td>
<pre>% php singleton.php Handle = Object id #3Handle = Object id #3%</pre>
</td>
</tr>
</table>
<p>返回的两个句柄是同一对象。如果您在整个应用程序中使用数据库连接单元素，那么就可以在任何地方重用同一句柄。</p>
<p>您可以使用全局变量存储数据库句柄，但是，该方法仅适用于较小的应用程序。在较大的应用程序中，应避免使用全局变量，并使用对象和方法访问资源。</p>
<p>观察者模式</p>
<p>观察者模式为您提供了避免组件之间紧密耦合的另一种方法。该模式非常简单：一个对象通过添加一个方法（该方法允许另一个对象，即<em>观察者</em> 注册自己）使本身变得可观察。当可观察的对象更改时，它会将消息发送到已注册的观察者。这些观察者使用该信息执行的操作与可观察的对象无关。结果是对象可以相互对话，而不必了解原因。</p>
<p>一个简单示例是系统中的用户列表。清单 4 中的代码显示一个用户列表，添加用户时，它将发送出一条消息。添加用户时，通过发送消息的日志观察者可以观察此列表。</p>
<p><b>清单 4. Observer.php</b><br />
<table>
<tr>
<td>
<pre>&lt;?phpinterface IObserver{ function onChanged( $sender, $args );}

interface IObservable{ function addObserver( $observer );}

class UserList implements IObservable{ private $_observers = array();

public function addCustomer( $name ) {  foreach( $this-&gt;_observers as $obs )   $obs-&gt;onChanged( $this, $name ); }

public function addObserver( $observer ) {  $this-&gt;_observers []= $observer; }}

class UserListLogger implements IObserver{ public function onChanged( $sender, $args ) {  echo( ""$args" added to user list\n" ); }}

$ul = new UserList();$ul-&gt;addObserver( new UserListLogger() );$ul-&gt;addCustomer( "Jack" );?&gt;</pre>
</td>
</tr>
</table>
<p>此代码定义四个元素：两个接口和两个类。<code>IObservable</code> 接口定义可以被观察的对象，<code>UserList</code> 实现该接口，以便将本身注册为可观察。<code>IObserver</code> 列表定义要通过怎样的方法才能成为观察者，<code>UserListLogger</code> 实现 <code>IObserver</code> 接口。图 4 的 UML 中展示了这些元素。</p>
<p><b>图 4. 可观察的用户列表和用户列表事件日志程序</b><br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAxMTMyNjE2NTM5OTQwLmdpZg==.jpg"></p>
<p>如果在命令行中运行它，您将看到以下输出：</p>
<table>
<tr>
<td>
<pre>% php observer.php "Jack" added to user list%</pre>
</td>
</tr>
</table>
<p>测试代码创建 <code>UserList</code>，并将 <code>UserListLogger</code> 观察者添加到其中。然后添加一个消费者，并将这一更改通知 <code>UserListLogger</code>。</p>
<p>认识到 <code>UserList</code> 不知道日志程序将执行什么操作很关键。可能存在一个或多个执行其他操作的侦听程序。例如，您可能有一个向新用户发送消息的观察者，欢迎新用户使用该系统。这种方法的价值在于 <code>UserList</code> 忽略所有依赖它的对象，它主要关注在列表更改时维护用户列表并发送消息这一工作。</p>
<p>此模式不限于内存中的对象。它是在较大的应用程序中使用的数据库驱动的消息查询系统的基础。</p>
<p>命令链模式</p>
<p><em>命令链</em> 模式以松散耦合主题为基础，发送消息、命令和请求，或通过一组处理程序发送任意内容。每个处理程序都会自行判断自己能否处理请求。如果可以，该请求被处理，进程停止。您可以为系统添加或移除处理程序，而不影响其他处理程序。清单 5 显示了此模式的一个示例。</p>
<p><b>清单 5. Chain.php</b><br />
<table>
<tr>
<td>
<pre>&lt;?phpinterface ICommand{ function onCommand( $name, $args );}

class CommandChain{ private $_commands = array();

public function addCommand( $cmd ) {  $this-&gt;_commands []= $cmd; }

public function runCommand( $name, $args ) {  foreach( $this-&gt;_commands as $cmd )  {   if ( $cmd-&gt;onCommand( $name, $args ) )    return;  } }}

class UserCommand implements ICommand{ public function onCommand( $name, $args ) {  if ( $name != "addUser" ) return false;  echo( "UserCommand handling "addUser"\n" );  return true; }}

class MailCommand implements ICommand{ public function onCommand( $name, $args ) {  if ( $name != "mail" ) return false;  echo( "MailCommand handling "mail"\n" );  return true; }}

$cc = new CommandChain();$cc-&gt;addCommand( new UserCommand() );$cc-&gt;addCommand( new MailCommand() );$cc-&gt;runCommand( "addUser", null );$cc-&gt;runCommand( "mail", null );?&gt;</pre>
</td>
</tr>
</table>
<p>此代码定义维护 <code>ICommand</code> 对象列表的 <code>CommandChain</code> 类。两个类都可以实现 <code>ICommand</code> 接口 —— 一个对邮件的请求作出响应，另一个对添加用户作出响应。 图 5 给出了 UML。</p>
<p><b>图 5. 命令链及其相关命令</b><br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAxMTMyNjE2NTQwMjczLmdpZg==.jpg"></p>
<p>如果您运行包含某些测试代码的脚本，则会得到以下输出：</p>
<table>
<tr>
<td>
<pre>% php chain.php UserCommand handling "addUser"MailCommand handling "mail"%</pre>
</td>
</tr>
</table>
<p>代码首先创建 <code>CommandChain</code> 对象，并为它添加两个命令对象的实例。然后运行两个命令以查看谁对这些命令作出了响应。如果命令的名称匹配 <code>UserCommand</code> 或 <code>MailCommand</code>，则代码失败，不发生任何操作。</p>
<p>为处理请求而创建可扩展的架构时，命令链模式很有价值，使用它可以解决许多问题。</p>
<p>策略模式</p>
<p>我们讲述的最后一个设计模式是<em>策略</em> 模式。在此模式中，算法是从复杂类提取的，因而可以方便地替换。例如，如果要更改搜索引擎中排列页的方法，则策略模式是一个不错的选择。思考一下搜索引擎的几个部分 —— 一部分遍历页面，一部分对每页排列，另一部分基于排列的结果排序。在复杂的示例中，这些部分都在同一个类中。通过使用策略模式，您可将排列部分放入另一个类中，以便更改页排列的方式，而不影响搜索引擎的其余代码。</p>
<p>作为一个较简单的示例，清单 6 显示了一个用户列表类，它提供了一个根据一组即插即用的策略查找一组用户的方法。</p>
<p><b>清单 6. Strategy.php</b><br />
<table>
<tr>
<td>
<pre>&lt;?phpinterface IStrategy{ function filter( $record );}

class FindAfterStrategy implements IStrategy{ private $_name;

public function __construct( $name ) {  $this-&gt;_name = $name; }

public function filter( $record ) {  return strcmp( $this-&gt;_name, $record ) &lt;= 0; }}

class RandomStrategy implements IStrategy{ public function filter( $record ) {  return rand( 0, 1 ) &gt;= 0.5; }}

class UserList{ private $_list = array();

public function __construct( $names ) {  if ( $names != null )  {   foreach( $names as $name )   {    $this-&gt;_list []= $name;   }  } }

public function add( $name ) {  $this-&gt;_list []= $name; }

public function find( $filter ) {  $recs = array();  foreach( $this-&gt;_list as $user )  {   if ( $filter-&gt;filter( $user ) )    $recs []= $user;  }  return $recs; }}

$ul = new UserList( array( "Andy", "Jack", "Lori", "Megan" ) );$f1 = $ul-&gt;find( new FindAfterStrategy( "J" ) );print_r( $f1 );

$f2 = $ul-&gt;find( new RandomStrategy() );print_r( $f2 );?&gt;</pre>
</td>
</tr>
</table>
<p>此代码的 UML 如图 6 所示。</p>
<p><b>图 6. 用户列表和用于选择用户的策略</b><br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAxMTMyNjE2NTQwNjIxLmdpZg==.jpg"></p>
<p><code>UserList</code> 类是打包名称数组的一个包装器。它实现 <code>find</code> 方法，该方法利用几个策略之一来选择这些名称的子集。这些策略由 <code>IStrategy</code> 接口定义，该接口有两个实现：一个随机选择用户，另一个根据指定名称选择其后的所有名称。运行测试代码时，将得到以下输出：</p>
<table>
<tr>
<td>
<pre>% php strategy.php Array(  [0] =&gt; Jack  [1] =&gt; Lori  [2] =&gt; Megan)Array(  [0] =&gt; Andy  [1] =&gt; Megan)%</pre>
</td>
</tr>
</table>
<p>测试代码为两个策略运行同一用户列表，并显示结果。在第一种情况中，策略查找排列在 <code>J</code> 后的任何名称，所以您将得到 Jack、Lori 和 Megan。第二个策略随机选取名称，每次会产生不同的结果。在这种情况下，结果为 Andy 和 Megan。</p>
<p>策略模式非常适合复杂数据管理系统或数据处理系统，二者在数据筛选、搜索或处理的方式方面需要较高的灵活性。</p>
<p>结束语</p>
<p>本文介绍的仅仅是 PHP 应用程序中使用的几种最常见的设计模式。在<em>设计模式</em> 一书中演示了更多的设计模式。不要因架构的神秘性而放弃。模式是一种绝妙的理念，适用于任何编程语言、任何技能水平。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索对象<br />
                    ，                设计模式<br />
                    ，                方法<br />
                    ，                代码<br />
                    ，                模式<br />
                    ，                一个<br />
                    ，                php运行模式<br />
                    ，                php的运行模式<br />
                    ，                php观察者模式<br />
                                    代码模式<br />
                                    php常见的设计模式、php常见设计模式、诗歌鉴赏答题模式小结、常见的设计模式、常见设计模式，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 14:55:39</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e4%bb%a3%e7%a0%81/" title="代码">代码</a>, <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%bc%8f/" title="模式">模式</a>, <a href="https://www.iamivan.net/tag/%e5%af%b9%e8%b1%a1/" title="对象">对象</a>, <a href="https://www.iamivan.net/tag/%e8%ae%be%e8%ae%a1%e6%a8%a1%e5%bc%8f/" title="设计模式">设计模式</a>, <a href="https://www.iamivan.net/tag/php%e8%bf%90%e8%a1%8c%e6%a8%a1%e5%bc%8f/" title="php运行模式">php运行模式</a>, <a href="https://www.iamivan.net/tag/php%e7%9a%84%e8%bf%90%e8%a1%8c%e6%a8%a1%e5%bc%8f/" title="php的运行模式">php的运行模式</a>, <a href="https://www.iamivan.net/tag/php%e8%a7%82%e5%af%9f%e8%80%85%e6%a8%a1%e5%bc%8f/" title="php观察者模式">php观察者模式</a>, <a href="https://www.iamivan.net/tag/%e4%bb%a3%e7%a0%81%e6%a8%a1%e5%bc%8f/" title="代码模式">代码模式</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>常见的PHP五种设计模式小结的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjmAK0z.html" rel="bookmark">常见的PHP五种设计模式小结&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				设计模式 一书将设计模式引入软件社区,该书的作者是 Erich Gamma.Richard Helm.Ralph Johnson 和 John Vlissides Design(俗称 &quot;四人帮&quot;).所介绍的设计模式背后的核心概念非常简单.经过多年的软件开发实践,Gamma 等人发现了某些具有固定设计的模式,就像建筑师设计房子和建筑物一样,可以为浴室的位置或厨房的构造方式开发模板.使用这些模板或者说设计模式 意味着可以更快地设计更好的建筑物.同样的概念也适用于软件. 设计模式不仅代表着更			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvJ71M.html" rel="bookmark">C&num;后台调用前台javascript的五种方法小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在网上找了找,发现有三种方法可以访问到前台代码: 第一种,OnClientClick (vs2003不支持这个方法) &lt;asp:Button ID=&quot;Button1&quot; runat=&quot;server&quot; Text=&quot;Button&quot; OnClientClick=&quot;client_click()&quot; /&gt; client_click() 就是javascript的一个方法. 第二种,Button1.Attributes.Add(&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxE46Pp.html" rel="bookmark">C&num;后台调用前台javascript的五种方法小结&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在网上找了找,发现有三种方法可以访问到前台代码: 第一种,OnClientClick (vs2003不支持这个方法) &lt;asp:Button ID=&quot;Button1&quot; runat=&quot;server&quot; Text=&quot;Button&quot; OnClientClick=&quot;client_click()&quot; OnClick=&quot;Button1_Click&quot; /&gt; client_click() 就是javascript的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ2JXwz.html" rel="bookmark">jQuery插件开发的五种形态小结&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于jQuery插件的开发自己也做了少许研究,自己也写过多个插件,在自己的团队了也分享过一次关于插件的课.开始的时候整觉的很复杂的代码,现在再次看的时候就清晰了许多.这里我把我自己总结出来的东西分享出来,帮助那些和我一样曾经遇到过同样问题的人. 我要做什么 我想要得到的javascript 插件应该会有以下几个特征 代码相对独立 链式操作 插件可配置 有可操作的方法,插件的生命周期可控制 配置可被缓存 可扩展 无冲突处理 事件代理,动态初始化 * 以下的代码均假设存在 jQuery 插件的第一形			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV7kJYb.html" rel="bookmark">最常用的12种设计模式小结&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.策略模式(Strategy): 定义了算法家族, 分别封装起来, 让它们之间可以互相替换. 比如Collections.sort(List list, Comparator c); 可以通过实现多个Comparator接口来达到多种排序的目的. 2.装饰着模式(Decorator): 动态的给一个对象添加一些额外的职责. 比如java.io包. BufferedInputStream封装了FileInputStream, 它们都实现了InputStream接口, 但前者实现了readLine			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEdO0Az.html" rel="bookmark">三个类概括PHP的五种设计模式&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				工厂模式 单元素模式 观察者模式 命令链模式 策略模式 复制代码 代码如下: class people { private $name = ''; private $user = null; private function __constract($name){/*此处private定义辅助实现 单元素模式*/ $this-&gt;name = $name; } public static function instance($name){/*此方法实现 工厂模式*/ static $object			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWxR0jp.html" rel="bookmark">Shell&period;Application执行命令的五种方法小结&lowbar;vbs</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当初老马写这个版本时,我测试过简繁两个2003版本的,当是是好用的.我猜测很可能与2003打了ms06014补丁有关.kyo在冰点论坛提出了解决方法,我今天下午研究了一下这个组件,发现它有5种方法可以执行命令.以下是vbs版本(asp版不提供了,如何利用asp版本在2003的webshell中运行命令,自己解决吧:-): 复制代码 代码如下: Set objShellApp = CreateObject(&quot;Shell.Application&quot;) Set objFolder = objS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7kKoZz.html" rel="bookmark">向用户征询IOS授权的五种常见设计模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  小文一篇,话题仍与上周衔接,小结了五种在iOS中向用户申请权限的实践模式,可参考.下面进入译文. 对于iOS app,当功能涉及到推送通知.访问照片或调用相机.获取地理位置等等时,都需要向用户申请授权.申请会发生在app运行的过程中,而不是像Android那样在安装的时候就莫名其妙的问用户是否同意app调用某些系统功能.不过如今Android也在向iOS的方式靠拢. 对于产品设计方而言,这里最大的问题在于,iOS只给你一次机会去征询授权 – 一旦那些缺乏耐心和理性的用户(多数用户)出于无论什			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4NJ7JM.html" rel="bookmark">jQuery插件开发的五种形态&lbrack;转&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这篇文章主要介绍了jQuery插件开发的五种形态小结,具体的内容就是解决javascript插件的8种特征,非常的详细. 关于jQuery插件的开发自己也做了少许研究,自己也写过多个插件,在自己的团队了也分享过一次关于插件的课.开始的时候整觉的很复杂的代码,现在再次看的时候就清晰了许多.这里我把我自己总结出来的东西分享出来,帮助那些和我一样曾经遇到过同样问题的人. 我要做什么 我想要得到的javascript 插件应该会有以下几个特征: [ ] 代码相对独立 [ ] 链式操作 [ ] 插件可配置			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOwmmz.html" rel="bookmark" class="title">DotNet 资源大全中文版</a>
					<div>
						原文:DotNet 资源大全中文版 转自:https://github.com/jobbole/awesome-dotnet-cn 我想很多程序员应该记得 GitHub 上有一个 Awesome -  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7D7rb.html" rel="bookmark" class="title">如何使用ASP制作模似动态生长的表单&quest;</a>
					<div>
						FILE: DYNAFORM.ASP&lt;%@ language = vbscript%&gt;&lt;% Response.Expires = 0 %&gt;&lt;HTML&gt;&lt;HEA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpk8w1z.html" rel="bookmark" class="title">用Fireworks批处理缩放图片大小</a>
					<div>
						这个也许是在一些大网站用得最多的功能,因为他们总会有很多的图要近行放大缩小之类的操作. 而FW却可以轻松搞定. 在批处理对话框里添加缩放(Scale)以改变图片输出的宽和高. 设置批处理文件的缩放属性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMg7qZM.html" rel="bookmark" class="title">二级站、栏目站对SEO的利弊 你是否知晓？</a>
					<div>
						大家好,很久没有与大家分享过经验了,最近的一段时间里笔者一直都在学习关于网站内部优化的相关问题,今天笔者与大家在这里分享一下,希望对各位站长有所帮助.首先笔者在这里解释一下什么是二级域名,很明显的使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW126Gz.html" rel="bookmark" class="title">在Linux下实现路由功能的原理及实验</a>
					<div>
						一:原理:软路由是指利用台式机或服务器配合软件形成路由解决方案,主要靠软件的设置,达成路由器的功能.软路由通常使用普通计算机充当,使用通用的操作系统,如linux或windows,因此路由设置事实上是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jNJ3b.html" rel="bookmark" class="title">关于CSS控制表格文字样式的研究</a>
					<div>
						即使在DIV满天飞的今天,Table在网页的布局中还是少不了的,因为当需要输出数据时,Table布局远远比DIV布局有优势,而且同样的我们可以通过CSS来控制表格样式.要知道WEB标准并非是通篇的DI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrW05p.html" rel="bookmark" class="title">通过XML进行发布</a>
					<div>
						当进入一个基于 XML 的发布环境后,如果正确地计划和设计结构,那么使用正确的方法可以节省时间,甚至会产生新的发布范式.XML 是一种功能强大的内容处理工具,可以将混合了文本和对象的文档转换为可排序的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0POm6M.html" rel="bookmark" class="title">Ruby on rails开发从头来（windows）（十四）-送货处理</a>
					<div>
						在上次的内容里,我们完成了订单的编写.这次我们模拟一个简单的送货页面,给这个购物车的管理员用. 1.首先,我们修改order表,给他添加一个字段shipped_at: create table ord ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDA2KOb.html" rel="bookmark" class="title">为什么选择360极速浏览器？</a>
					<div>
						360极速浏览器有着以下特点: - 无缝顺滑的双核切换,网购.秒杀快捷流畅. - 全球最快的浏览器内核,网页闪电般打开. - 360云安全体系+系统级安全特性,全面保护上网安全. - 大量为您精选的功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kjOaz.html" rel="bookmark" class="title">php无法上传大文件完美解决方案</a>
					<div>
						  php.ini无法上传大文件完美解决办法 1.打开php.ini(打开方式就不用说了,百度一大堆) 2.查找post_max_size 表单提交最大数值,此项不是限制上传单个文件的大小,而是针对整 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNRY0M.html" rel="bookmark" class="title">如何在win7中自定义输入法图标</a>
					<div>
						  在桌面任务栏上右键点击输入法图标,选择&quot;设置&quot;,如图所示: 在弹出的窗口中,点击&quot;中文(简体)---美式键盘&quot;,在右侧看到&quot;属性&quot;按钮, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdXROM.html" rel="bookmark" class="title">笔记本电脑连接内置声卡音箱的正确设置</a>
					<div>
						  1.将音箱连接到笔记本的USB接口,等待电脑识别,一般情况下,电脑会自动将声卡切换为这个USB声卡,假如没有切换需要重启音箱,仍然没用的话再跳到一下步骤; 2.点击右下角任务栏的声音图标,可以看到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQ0EAp.html" rel="bookmark" class="title">网页显示SQL语句错误？？？</a>
					<div>
						问题描述 网页显示SQL语句错误??? 网页显示 (Table 'zjwdb_305329.wy_kefu' doesn't exist [ SQL语句 ] : SHOW COLUMNS FROM w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwmJyM.html" rel="bookmark" class="title">网站换域名的那些事</a>
					<div>
						域名是公司和人站长最重要的无形资产.所有的网站内容.流量都与特定的域名相联系.域名尽量都不会换,但是始终有一些意外情况会使我们必须换域名. 在互联网企业中,每一天差不多都有企业或网站在换域名,他们为什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvmr19b.html" rel="bookmark" class="title">iOS开发网络篇&mdash;网络编程基础</a>
					<div>
						一.为什么要学习网络编程 1.简单说明 在移动互联网时代,移动应用的特征有: (1)几乎所有应用都需要用到网络,比如QQ.微博.网易新闻.优酷.百度地图 (2)只有通过网络跟外界进行数据交互.数据更新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNj7WJM.html" rel="bookmark" class="title">Visual Studio 2013 Xamarin for iOS 环境搭建</a>
					<div>
						原文:Visual Studio 2013 Xamarin for iOS 环境搭建 一.Mac安装Xamarin.iOS 1,我的Mac 环境:OSX 10.10.3.Xcode 6.3.2 (使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB4Ovb.html" rel="bookmark" class="title">高性能Vs性价比，总有一款适合你，阿里云NAS家族深度解析</a>
					<div>
						在今年召开的&quot;2017杭州·云栖大会&quot;上,阿里云文件存储(Network Attached Storage,简称NAS)再次释放技术红利,降价幅度达46%,再次成为云上存储的性价比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQB8NoM.html" rel="bookmark" class="title">学网站制作其实也不难</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 说真的,建站不是一件很容易的事,建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBnOvb.html" rel="bookmark" class="title">关于拖动事件的小问题</a>
					<div>
						问题描述 请问从一个listView拖动一个项到另一个listView的话,怎样在拖动到目标listview时设置(还未mouseup时候)光标,跟windows中的拖动文件时候发生相同的事件所产生的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5AVlM.html" rel="bookmark" class="title">乔治&amp;amp&semi;&num;12539&semi;阿玛尼联合三星发布豪华版Galaxy S手机</a>
					<div>
						乔治·阿玛尼再次与三星合作,发布了一个更加独特和豪华的Android智能手机Galaxy S的进阶版,它拥有阿玛尼的贴牌和不同的背面材质,硬件配置情况应该和现有基础版本无异,但内置的阿玛尼定制应用程序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnGNNM.html" rel="bookmark" class="title">sqlserver2005-mySQL数据导入到SQLserver数据库</a>
					<div>
						问题描述 mySQL数据导入到SQLserver数据库 如题,怎么才能做到将mySQL数据导入到SQLserver数据库,mySQL to sqlserver2005怎么用 解决方案 我之前是先将my ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9x4wXb.html" rel="bookmark" class="title">天天酷跑钻石怎么获得 快速刷钻石技巧心得分享</a>
					<div>
						1.充值钻石.只限于土豪级玩家,因为充钻石通常花费太大,不太适合平民级玩家. 2.任务获得.任务中平均每天完成任务可以获得50多个钻石,累积下来收获颇丰! 3.抽奖获得.现在各位玩家通过累积积分就有抽 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQDrkp.html" rel="bookmark" class="title">网络编程-如何修改从本机发送出去的数据包的MAC地址</a>
					<div>
						问题描述 如何修改从本机发送出去的数据包的MAC地址 例如,本机的MAC地址为: ?00-1C-47-CE-FE-02,在发送数据包的时候,如何将其修改为?00-11-42-DF-EE-01 1.不能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5RnWp.html" rel="bookmark" class="title">新手求解：c&plus;&plus;中的构造函数问题求解</a>
					<div>
						问题描述 新手求解:c++中的构造函数问题求解 #include using namespace std; class Clock { public: Clock() /* { }就是这个大括号,不加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRyGOp.html" rel="bookmark" class="title">flex AdvancedDataGrid 实现单元格合并行（或者其他方法能实现）求助大神！！！</a>
					<div>
						问题描述 flex AdvancedDataGrid 实现单元格合并行(或者其他方法能实现)求助大神!!! 解决方案 2013.12.04 JS实现单元格的合并Javascript实现合并单元格使用X ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjx5WM.html" rel="bookmark" class="title">OpenGLES 如何在十天内掌握线性代数 - 希望这是真的！</a>
					<div>
						OpenGLES 如何在十天内掌握线性代数 - 希望这是真的! 太阳火神的美丽人生 (http://blog.csdn.net/opengl_es) 本文遵循&quot;署名-非商业用途-保持一致&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrEDlp.html" rel="bookmark" class="title">python正则表达式匹配中文详解</a>
					<div>
						如果你需要知道在python中匹配中文汉字的话我们就必须先查看下表 UTF8 [x01-x7f]|[xc0-xdf][x80-xbf]|[xe0-xef][x80-xbf]{2}|[xf0-xff][ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrQ1lp.html" rel="bookmark" class="title">Android 数据库文件存取至储存卡的方法&lowbar;Android</a>
					<div>
						废话不多说了,直接给大家贴代码了,具体代码如下 &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt; &lt;LinearL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jd9Kp.html" rel="bookmark" class="title">PHP实现的封装验证码类详解&lowbar;php技巧</a>
					<div>
						用PHP写一个验证码类,并进行封装.类名: validationcode.class.php代码如下: 复制代码 代码如下: &lt;?php class ValidationCode {  priv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1OKKb.html" rel="bookmark" class="title">集成环信ios SDK时，编译出错</a>
					<div>
						问题描述 Build target PartnerTestsLd /Users/fusainan/Library/Developer/Xcode/DerivedData/Partner-fwsaicl ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
